package lib;

sub decorate
{
  my ($num,$type,$time,$name,$title,$text,$TSTYLE,$c,$lag)=@_;
  my $html='';

  if($title eq '')
  {
    if($type eq 'vote')
    {
      $title='場内票数';
    }
  }
  if($type eq 'hearer' && $c>0)
  {
    $title.=sprintf('傍聴者 - No.%d',$c);
  }

  my $s='';
  if($lag>0 && $time+$lag<time()){$s='o';}
  if($type eq 'vote' || $type eq 'hearer'){$TSTYLE='high';}

  #if($type eq 'vote')
  #{
  #  my @num=();
  #  while($text=~/([0-9]+)/g){push(@num,$1);}
  #  if(scalar(@num)==1){$title.=sprintf(' ( %d )',$num[0]);}
  #}
#$text=&hutool::DECODE('テスト');
  $html.=sprintf('<table class="%s%s">',$s,$TSTYLE);
  $html.=sprintf('<tr><td><input type="checkbox" id="check_%d" onclick="check_list(%d);"/><b>%s</b></td><td class="right"><b>%s</b></td></tr>'
                ,$num,$num,$title,$name);
  $html.=sprintf('<tr><td colspan="2" class="text">%s<div class="right">%s</div></td></tr>',$text,&print_time($time));

  $html.=sprintf('</table>%s',"\n");

  return $html;
}

sub log_read
{
  my ($page,$log_file,$page_max)=@_;
  my @line=&hutool::OPEN_FILE($log_file);

  if(scalar(@line)==0){return 0;}

  if($page_max>0)
  {
    my $b=0;
    my $e=0;
    if(scalar(@line)>=$page_max*$page)    {$b=$page_max*$page;}
    if(scalar(@line)>=$page_max*($page+1)){$e=$page_max*($page+1)-1;}else{$e=scalar(@line);}
    return @line[$b..$e];
  }else
  {
    return @line;
  }

}

sub data_split
{
  my($data) = @_;
  my %ret;

  if($data=~/\t/)
  {
    my @data = split(/[\t\n]/,$data);

    $ret{'num'}  =$data[0];
    $ret{'time'} =$data[1];
    $ret{'type'} =$data[2];
    $ret{'title'}=$data[3];
    $ret{'name'} =$data[4];
    $ret{'text'} =$data[5];
  }else
  {
    $ret{'num'}=$ret{'time'}=$ret{'type'}=$ret{'title'}=$ret{'name'}=$ret{'text'}=0;
  }

  return %ret;
}

sub print_time
{
  my($sec,$min,$hour,$day,$month,$year)=localtime($_[0]);
  return sprintf('%d/%02d/%02d %02d時%02d分%02d秒',$year+1900,$month+1,$day,$hour,$min,$sec);
}

sub wide2half
{
  my ($val)=@_;
  my @num=('０','１','２','３','４','５','６','７','８','９');
  my $n;
  for($n=0;$n<=9;++$n){$val=~s/$num[$n]/$n/g;}


  return $val;
}

1;
